const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const bills = sequelize.define(
    'bills',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      invoice_no: {
        type: DataTypes.TEXT,
      },

      invoice_date: {
        type: DataTypes.DATE,
      },

      due_date: {
        type: DataTypes.DATE,
      },

      amount: {
        type: DataTypes.DECIMAL,
      },

      currency: {
        type: DataTypes.TEXT,
      },

      category: {
        type: DataTypes.TEXT,
      },

      status: {
        type: DataTypes.ENUM,

        values: ['Pending', 'Paid', 'Overdue'],
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  bills.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    db.bills.hasMany(db.payments, {
      as: 'payments_bill',
      foreignKey: {
        name: 'billId',
      },
      constraints: false,
    });

    //end loop

    db.bills.belongsTo(db.vendors, {
      as: 'vendor',
      foreignKey: {
        name: 'vendorId',
      },
      constraints: false,
    });

    db.bills.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });

    db.bills.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.bills.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return bills;
};
